FQ.MD.WEB/ViewModels/Form/GroupForms.cs
using FQ.MD.WEB.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FQ.MD.WEB.ViewModels.Form
{
    public class GroupAddForm
    {
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string GroupName { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public int CompanyId { get; set; }
        public int? ParentId { get; set; }
        public string Note { get; set; }
        public bool IsActive { get; set; }
    }

    public class GroupEditForm
    {
        public int GroupId { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string GroupName { get; set; }
        public int? ParentId { get; set; }
        public int CompanyId { get; set; }
        public string Note { get; set; }
        public bool IsActive { get; set; }
    }

    public class GroupDeleteForm
    {
        public int GroupId { get; set; }
        public string GroupName { get; set; }
        public int CompanyId { get; set; }
        public int? ParentId { get; set; }
        public string Note { get; set; }
        public bool IsActive { get; set; }
        [Required(ErrorMessageResourceType = typeof(Res), ErrorMessageResourceName = "ValidationRequired")]
        public string Remark { get; set; }
    }
}

FQ.MD.WEB/ViewModels/GroupViewModels.cs
using FQ.MD.WEB.Resources;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Web;

namespace FQ.MD.WEB.ViewModels
{
    public class GroupViewModel
    {
        public int GroupId { get; set; }
        public string GroupName { get; set; }
        public string Company { get; set; }
        public string Parent { get; set; }
        public string Note { get; set; }

        public string Active { get; set; }
        public string Actions { get; set; }
    }
}

FQ.MD.WEB/Controllers/GroupsController.cs
using FQ.MD.WEB.ViewModels.JSON;
using FQ.MD.WEB.Models;
using FQ.MD.WEB.Resources;
using FQ.MD.WEB.Services;
using FQ.MD.WEB.ViewModels;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Web;
using System.Web.Mvc;
using FQ.MD.WEB.ViewModels.Form;

namespace FQ.MD.WEB.Controllers
{
    [Authorize]
    public class GroupsController : BaseController
    {
        private GroupServices _groupServices = new GroupServices();
        private CompanyServices _companyServices = new CompanyServices();

        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public JsonResult Index(DataTables model)
        {
            var searchKeywords = !String.IsNullOrEmpty(model.search.value) ? model.search.value.ToLower() : "";

            string sortBy = "GroupName";
            bool sortDir = true;

            if (model.order != null)
            {
                sortBy = model.columns[model.order[0].column].data;
                sortDir = model.order[0].dir.ToLower() == "asc";
            }

            Expression<Func<GT_MASTER_GROUPS, bool>> filter = u => u.GroupName.ToLower().Contains(searchKeywords) || u.GT_MASTER_COMPANIES.CompanyName.ToLower().Contains(searchKeywords);
            Func<IQueryable<GT_MASTER_GROUPS>, IOrderedQueryable<GT_MASTER_GROUPS>> orderBy = q => sortDir ? q.OrderBy(u => u.GroupName) : q.OrderByDescending(u => u.GroupName);

            if (sortBy == "Parent")
            {
                orderBy = q => sortDir ? q.OrderBy(u => u.GT_MASTER_GROUPS2.GroupName) : q.OrderByDescending(u => u.GT_MASTER_GROUPS2.GroupName);
            }

            if (sortBy == "Active")
            {
                orderBy = q => sortDir ? q.OrderBy(u => u.IsActive) : q.OrderByDescending(u => u.IsActive);
            }

            var models = _groupServices.Get(filter: filter, orderBy: orderBy, skip: model.start, take: model.length)
                .Select(c => new GroupViewModel
                {
                    GroupName = c.GroupName,
                    Parent = c.ParentId.HasValue ? c.GT_MASTER_GROUPS2.GroupName : "-",
                    Active = DisplayActiveIcon(c.IsActive),
                    Actions = DisplayActions(UserAuthorization, c.GroupId, null)
                });

            var totalResultsCount = _groupServices.Get().Count();
            var recordsFiltered = String.IsNullOrEmpty(model.search.value) ? totalResultsCount : _groupServices.Get(filter: filter).Count();

            return Json(new
            {
                draw = model.draw,
                recordsTotal = totalResultsCount,
                recordsFiltered = recordsFiltered,
                data = models.ToList()
            });
        }

        public ActionResult Add()
        {
            ViewBag.CompanyId = CompanyOptions(null);
            ViewBag.ParentId = GroupOptions(null);
            return View();
        }

        [HttpPost]
        public ActionResult Add(GroupAddForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _groupServices.AddGroup(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }

                var message = DisplayMessage(action.Message, new string[] { "GroupName" });
                ModelState.AddModelError("", message);
            }

            ViewBag.CompanyId = CompanyOptions(form.CompanyId);
            ViewBag.ParentId = GroupOptions(form.ParentId);
            return View(form);
        }

        public ActionResult Edit(int Id)
        {
            var model = _groupServices.GetGroupById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var form = new GroupEditForm();
            form.GroupId = model.GroupId;
            form.GroupName = model.GroupName;
            form.CompanyId = model.CompanyId;
            form.ParentId = model.ParentId;
            form.Note = model.Note;
            form.IsActive = model.IsActive;

            ViewBag.CompanyId = CompanyOptions(form.CompanyId);
            ViewBag.ParentId = GroupOptions(form.ParentId);
            return View(form);
        }

        [HttpPost]
        public ActionResult Edit(GroupEditForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _groupServices.UpdateGroup(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }

                var message = DisplayMessage(action.Message, new string[] { "GroupName" });
                ModelState.AddModelError("", message);
            }

            ViewBag.CompanyId = CompanyOptions(form.CompanyId);
            ViewBag.ParentId = GroupOptions(form.ParentId);
            return View(form);
        }

        public ActionResult Detail(int Id)
        {
            var model = _groupServices.GetGroupById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var viewModel = new GroupViewModel();
            viewModel.GroupId = model.GroupId;
            viewModel.GroupName = model.GroupName;
            viewModel.Company = model.GT_MASTER_COMPANIES.CompanyName;
            viewModel.Parent = model.ParentId.HasValue? model.GT_MASTER_GROUPS2.GroupName : "";
            viewModel.Note = model.Note;
            viewModel.Active = DisplayActiveIcon(model.IsActive);

            return View(viewModel);
        }

        public ActionResult Delete(int Id)
        {
            var model = _groupServices.GetGroupById(Id);
            if (model == null)
            {
                return RedirectToAction("Index", "NotFound");
            }

            var form = new GroupDeleteForm();
            form.GroupId = model.GroupId;
            form.GroupName = model.GroupName;
            form.CompanyId = model.CompanyId;
            form.ParentId = model.ParentId;
            form.Note = model.Note;
            form.IsActive = model.IsActive;

            ViewBag.CompanyId = CompanyOptions(form.CompanyId);
            ViewBag.ParentId = GroupOptions(form.ParentId);

            return View(form);
        }

        [HttpPost]
        public ActionResult Delete(GroupDeleteForm form)
        {
            if (ModelState.IsValid)
            {
                var action = _groupServices.DeleteGroup(form, UserAuthorized);
                if (action.IsSuccess)
                {
                    return RedirectToAction("Index");
                }
            }

            ViewBag.CompanyId = CompanyOptions(form.CompanyId);
            ViewBag.ParentId = GroupOptions(form.ParentId);
            return View(form);
        }

        private SelectList CompanyOptions(int? CompanyId)
        {
            var Companies = _companyServices.Get(filter: q => q.IsActive, orderBy: q => q.OrderBy(x => x.CompanyName))
                .Select(g => new SelectItemIntValue
                {
                    Value = g.CompanyId,
                    Text = g.CompanyName
                }).ToList();
            Companies.Insert(0, new SelectItemIntValue() { Value = null, Text = Res.SelectItemNull });
            return new SelectList(Companies, "Value", "Text", CompanyId);
        }

        private SelectList GroupOptions(int? GroupId)
        {
            var Groups = _groupServices.Get(filter: q => q.IsActive, orderBy: q => q.OrderBy(x => x.GroupName))
                .Select(g => new SelectItemIntValue
                {
                    Value = g.GroupId,
                    Text = g.GroupName
                }).ToList();
            Groups.Insert(0, new SelectItemIntValue() { Value = null, Text = Res.SelectItemNull });
            return new SelectList(Groups, "Value", "Text", GroupId);
        }
    }
}

FQ.MD.WEB/Views/Groups/Add.cshtml
@model FQ.MD.WEB.ViewModels.Form.GroupAddForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Add;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Groups</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Group</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.GroupName, new { htmlAttributes = new { @class = "form-control" } })
                        @Html.ValidationMessageFor(model => model.GroupName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.DropDownList("CompanyId", null, htmlAttributes: new { @class = "form-control js-example-basic-single" })
                        @Html.ValidationMessageFor(model => model.CompanyId, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Parent</label>
                    <div class="col-md-6">
                        @Html.DropDownList("ParentId", null, htmlAttributes: new { @class = "form-control js-example-basic-single" })
                        @Html.ValidationMessageFor(model => model.ParentId, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Note</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Note, new {  @class = "form-control" } )
                        @Html.ValidationMessageFor(model => model.Note, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Add" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $('.js-example-basic-single').select2();
        });
    </script>
}

FQ.MD.WEB/Views/Groups/Delete.cshtml
@model FQ.MD.WEB.ViewModels.Form.GroupDeleteForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Delete;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Groups</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            @Html.HiddenFor(q => q.CompanyId)
            
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.GroupId)
                @Html.HiddenFor(model => model.ParentId)

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Group</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.GroupName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.DropDownList("CompanyId", null, htmlAttributes: new { @class = "form-control js-example-basic-single", @readonly = "readonly", @disabled = "disabled" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Parent</label>
                    <div class="col-md-6">
                        @Html.DropDownList("ParentId", null, htmlAttributes: new { @class = "form-control js-example-basic-single", @readonly = "readonly", @disabled = "disabled" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Note</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Note, new { @class = "form-control", @readonly = "readonly" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Remark</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Remark, new { @class = "form-control" })
                        @Html.ValidationMessageFor(model => model.Remark, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Delete" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Groups/Detail.cshtml
@model FQ.MD.WEB.ViewModels.GroupViewModel
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Show;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Groups</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Group</label>
                    <div class="col-md-6">
                        <label>@Model.GroupName</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        <label>@Model.Company</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Parent</label>
                    <div class="col-md-6">
                        <label>@Model.Parent</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Note</label>
                    <div class="col-md-6">
                        <label>@Model.Note</label>
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.Raw(Model.Active)
                        @Res.IsActive
                    </div>
                </div>
            </div>
        }
    </div>
</div>

FQ.MD.WEB/Views/Groups/Edit.cshtml
@model FQ.MD.WEB.ViewModels.Form.GroupEditForm
@using FQ.MD.WEB.Resources

@{
    ViewBag.Title = Res.Edit;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item"><a href="@Url.Action("Index")">@Res.Groups</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>


<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
        </div>
    </div>
    <div class="card-body">
        @using (Html.BeginForm())
        {
            @Html.AntiForgeryToken()
            <div class="form-horizontal">
                @Html.ValidationSummary(true, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.GroupId)

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Group</label>
                    <div class="col-md-6">
                        @Html.EditorFor(model => model.GroupName, new { htmlAttributes = new { @class = "form-control", @readonly = "readonly" } })
                        @Html.ValidationMessageFor(model => model.GroupName, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Company</label>
                    <div class="col-md-6">
                        @Html.DropDownList("CompanyId", null, htmlAttributes: new { @class = "form-control js-example-basic-single" })
                        @Html.ValidationMessageFor(model => model.CompanyId, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Parent</label>
                    <div class="col-md-6">
                        @Html.DropDownList("ParentId", null, htmlAttributes: new { @class = "form-control js-example-basic-single" })
                        @Html.ValidationMessageFor(model => model.ParentId, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Note</label>
                    <div class="col-md-6">
                        @Html.TextAreaFor(model => model.Note, new { @class = "form-control" } )
                        @Html.ValidationMessageFor(model => model.Note, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <label class="control-label col-md-2">@Res.Status</label>
                    <div class="col-md-6">
                        @Html.CheckBoxFor(model => model.IsActive, new { @checked = "checked" })
                        @Res.IsActive
                        @Html.ValidationMessageFor(model => model.IsActive, "", new { @class = "text-danger" })
                    </div>
                </div>

                <div class="form-group row">
                    <div class="offset-md-2 col-md-6">
                        <input type="submit" value="@Res.Edit" class="btn btn-sm btn-primary" />
                        <input type="reset" value="@Res.Reset" class="btn btn-sm btn-danger" />
                    </div>
                </div>
            </div>
        }
    </div>
</div>

@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $('.js-example-basic-single').select2();
        });
    </script>
}

FQ.MD.WEB/Views/Groups/Index.cshtml
@using FQ.MD.WEB.Resources
@{
    ViewBag.Title = Res.Groups;
}

<nav aria-label="breadcrumb">
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="/"><i class="fas fa-home"></i> Dashboard</a></li>
        <li class="breadcrumb-item active" aria-current="page">@ViewBag.Title</li>
    </ol>
</nav>

<div class="card">
    <div class="card-header">
        <div class="row">
            <div class="col-6">
                <h5 class="color-brand">@ViewBag.Title</h5>
            </div>
            <div class="col-6 text-right">
                <a class="btn btn-sm btn-primary" href="@Url.Action("Add")">@Res.Add @Res.Group</a>
            </div>
        </div>
    </div>
    <div class="card-body">
        <div class="table-responsive">
            <table id="datatable" class="table table-striped" style="width:100%">
                <thead>
                    <tr>
                        <th> @Res.Group </th>
                        <th> @Res.Parent </th>
                        <th> @Res.IsActive </th>
                        <th></th>
                    </tr>
                </thead>
                <tbody></tbody>
            </table>
        </div>
    </div>
</div>



@section Scripts{
    <script type="text/javascript">
        $(document).ready(function () {
            $('#datatable').DataTable({
                "bStateSave": true,
                "processing": true,
                "serverSide": true,
                "ajax": {
                    url: "@Url.Action("Index", "Groups")",
                    type: 'POST'
                },
                "language": {
                    "search": "@Res.Search",
                    "searchPlaceholder": "@Res.Keywords",
                    "lengthMenu": "@Res.Show _MENU_ @Res.Entries",
                    "zeroRecords": "@Res.NoData",
                    "info": "",
                    "infoEmpty": "@Res.NoData",
                    "infoFiltered": "",
                    "paginate": { "first": "|<", "previous": "<", "next": ">", "last": ">|"

                    }
                },
                "columns": [
                     { "data": "GroupName" },
                     { "data": "Parent" },
                     { "data": "Active", "className": 'text-center' },
                     { "data": "Actions", "className": 'text-right', "orderable": false }
                ]
            });
        });
    </script>
}